#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_NormalOutFishActivityCFG.h"
std::auto_ptr<Fish_NormalOutFishActivityCFG> Fish_NormalOutFishActivityCFG::msSingleton(nullptr);

int Fish_NormalOutFishActivityCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_NormalOutFishActivityCFGData* Fish_NormalOutFishActivityCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_NormalOutFishActivityCFGData>& Fish_NormalOutFishActivityCFG::GetMapData()
{
	return mMapData;
}

void Fish_NormalOutFishActivityCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_NormalOutFishActivityCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_NormalOutFishActivityCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mActivityId = element->IntAttribute("ActivityId");
		{
			const char* RoomList = element->Attribute("RoomList");
			std::vector<std::string> vecRoomList;
			boost::split(vecRoomList, RoomList, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRoomList.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRoomList[i].c_str(), &temp))
				{
					data.mRoomList.push_back(temp);
				}
			}
		}
		data.mRefreshId = element->IntAttribute("RefreshId");
		data.mName = element->Attribute("Name");
		data.mType = element->IntAttribute("Type");
		data.mParamID = element->IntAttribute("ParamID");
		data.mOutWeight = element->IntAttribute("OutWeight");
		data.mOutMaxCount = element->IntAttribute("OutMaxCount");
		{
			const char* FishTime = element->Attribute("FishTime");
			std::vector<std::string> vecFishTime;
			boost::split(vecFishTime, FishTime, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecFishTime.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecFishTime[i].c_str(), &temp))
				{
					data.mFishTime.push_back(temp);
				}
			}
		}
		data.mFishNotice = element->IntAttribute("FishNotice");
		data.mRouteGroup = element->IntAttribute("RouteGroup");
		data.mGroupID = element->IntAttribute("GroupID");
		data.mGroupMaxFish = element->IntAttribute("GroupMaxFish");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_NormalOutFishActivityCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_NormalOutFishActivityCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_NormalOutFishActivityCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_NormalOutFishActivityCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_NormalOutFishActivityCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "ActivityId", data.mActivityId);
		LuaCfgHelper::readVectorInt(L, "RoomList", data.mRoomList);
		LuaCfgHelper::readInt(L, "RefreshId", data.mRefreshId);
		LuaCfgHelper::readString(L, "Name", data.mName);
		LuaCfgHelper::readInt(L, "Type", data.mType);
		LuaCfgHelper::readInt(L, "ParamID", data.mParamID);
		LuaCfgHelper::readInt(L, "OutWeight", data.mOutWeight);
		LuaCfgHelper::readInt(L, "OutMaxCount", data.mOutMaxCount);
		LuaCfgHelper::readVectorInt(L, "FishTime", data.mFishTime);
		LuaCfgHelper::readInt(L, "FishNotice", data.mFishNotice);
		LuaCfgHelper::readInt(L, "RouteGroup", data.mRouteGroup);
		LuaCfgHelper::readInt(L, "GroupID", data.mGroupID);
		LuaCfgHelper::readInt(L, "GroupMaxFish", data.mGroupMaxFish);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_NormalOutFishActivityCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_NormalOutFishActivityCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_NormalOutFishActivityCFG* Fish_NormalOutFishActivityCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_NormalOutFishActivityCFG());
	}
	return msSingleton.get();
}

void Fish_NormalOutFishActivityCFG::Release()
{
	msSingleton.reset(nullptr);
}
